.\" GRAB Graph Layout and Browser System
.\" 
.\" Copyright (c) 1986, 1988 Regents of the University of California
.\" Copyright (c) 1989, Tera Computer Company
.\" 
.\" Permission to use, copy, modify, and distribute this software and its
.\" documentation for educational, research, and non-profit purposes and
.\" without fee is hereby granted, provided that the above copyright 
.\" notice appear in all copies and that both that copyright notice and
.\" this permission notice appear in supporting documentation, and that
.\" the name of the University of California not be used in advertising
.\" or publicity pertaining to distribution of the software without 
.\" specific, written prior permission.  Permission to incorporate this
.\" software into commercial products can be obtained from the Campus 
.\" Software Office, University of California, Berkeley, CA 94720.  
.\" The University of California makes no representations about the 
.\" suitability of this software for any purpose.  It is provided "as is" 
.\" without express or implied warranty.
.\" 
.\" Permission to use, copy, modify, and distribute this software and its
.\" documentation for educational, research, and non-profit purposes and
.\" without fee is hereby granted, subject only to the condition that Tera
.\" Computer Company makes no representation about the suitability of 
.\" this software for any purpose.  It is provided "as is" without express or 
.\" implied warranty.
.\"
.\" Furthermore, portions of this system
.\" Copyright (c) 1987, 1988, 1989 Stanford University
.\"
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided
.\" that the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation, and that the name of Stanford not be used in advertising or
.\" publicity pertaining to distribution of the software without specific,
.\" written prior permission.  Stanford makes no representations about
.\" the suitability of this software for any purpose.  It is provided "as is"
.\" without express or implied warranty.
.\"
.\" STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
.\" IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
.\" DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
.\" WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH XGRAB local "11 September 1989"
.UC 4
.SH 
NAME
.IP
xgrab \- X graph browser
.SH 
SYNOPSIS
.IP
.B xgrab 
[ \-a \fIaspect ratio\fR ] 
[-C \fIcommandFileName\fR ] 
[ -t ] [ -l1 ] [ -l2 ]
[ -d\fIn\fR ] [ -s ] 
[ -b \fIBC-Percentage\fR ] [ -h\fIn\fR ]
[ \fIfilename\fR ] 
.SH 
DESCRIPTION
.IP
\fIXgrab\fP is an editor for directed graphs, derived from
the tool \fIsungrab\fP developed by the GRAB group at UC Berkeley.
The graph is specified in the file named \fIfilename\fP.
.IP
\fIXgrab\fP reads the file and automatically
lays out and displays the graph.  The user can then
edit the graph interactively (i.e., add, delete, and move nodes and edges),
create a PostScript(tm) version of the graph,
save the graph in a file for future editing, or perform many other functions.
.IP
The options are as follows:
.RS
.IP \fB\-a\fR
Allows the user to specify the initial \fIaspect ratio\fR of
the xgrab window.
That is, the number specified after
the \fB-a\fR flag controls the ratio of the x-axis width to the y-axis
width.  For example, invoking \fIxgrab\fR with the option \fI-a2\fR
will produce a window twice as wide as it is
tall.  The default aspect ratio is 1.5.  
.IP \fB\-C\fR
Specify a file of commands, \fIcommandFileName\fR,
that are to be executed on the graph on startup.
.IP \fB\-t\fR
Print the time required for various steps in the layout routine.
.IP \fB\-l1\fR
Stop the layout routine prematurely, before edge crossings have been
minimized.
.IP \fB\-l2\fR
Stop the layout routine prematurely, after edge crossings have been
minimized, but before the nodes are placed on the level
according to their barycenters.
.IP \fB\-d\fR
Specify the debug level for the code.  \fIn\fR should be digit from 0 to 3, 
with level 3 supplying the most information, level 0 the least.  Included
for backward capability with sungrab, and best if ignored.
.IP \fB\-s\fR
Set the showbc option, so that the barycenters of nodes are displayed with
the nodes.  Barycenters are used to determine the placing
of nodes on a level.  Also included for backward capability;
also best if ignored.
.IP \fB\-b\fR
Allows the user to specify the \fIBC-percentage\fR used when laying out the
graphs.  The higher the percentage, the closer dummy nodes will be to 
their parents/children.  Also included for backward capability; also highly
ignorable.
.IP \fB\-h\fR
Sets various heuristic flags.  Leave it alone.
.RE
.IP
Before running \fIxgrab\fP, it is necessary to start up \fIX\fP
and to open up a window.
.SH
BUGS AND SUCH
.IP
Command execution from files doesn't work as well as it ought to.
.IP
Disparaging remarks in the documentation are the opinions of the author,
and do not necessarily reflect the views of any of the large entities which
have given him employment over the years.
.SH 
SEE ALSO
.IP
.nf
X(1)
\fIIntroduction to GRAB\fP  (for historical information)
\fIHow To Use Xgrab\fR
\fIPostScript Language Reference Manual\fR
.SH 
AUTHORS
.IP
Greg Barnes at Tera Computer, and the GRAB group at UC Berkeley
.SH 
NOTES
.IP
\fIPostScript\fR is a trademark of Adobe Systems Incorporated
.fi
.RE
