.\" GRAB Graph Layout and Browser System
.\" 
.\" Copyright (c) 1986, 1988 Regents of the University of California
.\" Copyright (c) 1989, Tera Computer Company
.\" 
.\" Permission to use, copy, modify, and distribute this software and its
.\" documentation for educational, research, and non-profit purposes and
.\" without fee is hereby granted, provided that the above copyright 
.\" notice appear in all copies and that both that copyright notice and
.\" this permission notice appear in supporting documentation, and that
.\" the name of the University of California not be used in advertising
.\" or publicity pertaining to distribution of the software without 
.\" specific, written prior permission.  Permission to incorporate this
.\" software into commercial products can be obtained from the Campus 
.\" Software Office, University of California, Berkeley, CA 94720.  
.\" The University of California makes no representations about the 
.\" suitability of this software for any purpose.  It is provided "as is" 
.\" without express or implied warranty.
.\" 
.\" Permission to use, copy, modify, and distribute this software and its
.\" documentation for educational, research, and non-profit purposes and
.\" without fee is hereby granted, subject only to the condition that Tera
.\" Computer Company makes no representation about the suitability of 
.\" this software for any purpose.  It is provided "as is" without express or 
.\" implied warranty.
.\"
.\" Furthermore, portions of this system
.\" Copyright (c) 1987, 1988, 1989 Stanford University
.\"
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided
.\" that the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation, and that the name of Stanford not be used in advertising or
.\" publicity pertaining to distribution of the software without specific,
.\" written prior permission.  Stanford makes no representations about
.\" the suitability of this software for any purpose.  It is provided "as is"
.\" without express or implied warranty.
.\"
.\" STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
.\" IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
.\" DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
.\" WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.de HL
.br
\l'\\n(.lu-\\n(.iu'
.sp
..
.TL
How To Use Xgrab 
.br
(Version 2.3)
.AU
Greg Barnes
.AI
Tera Computer Company
400 N. 34th St., Suite 300
Seattle, WA 98103
.NH 
Introduction
.PP
\fIXgrab\fP (\fIX\fP \fIgra\fPph \fIb\fProwser) is a tool for the
automated layout and editing of directed graphs.  It runs on 
workstations under the \fIX window system\fP.  Xgrab reads an
input file containing a description of a directed graph, automatically
lays out the graph, and displays the graph on the screen.  The user can
then edit the graph interactively (i.e., add, remove, and move nodes
and edges), create a PostScript version of the file, save
the graph in a file for future editing, or perform many other features.
.PP
This manual begins with a description of xgrab's notion of a graph, to
provide a little background for the rest of the document.  Following that
is an explanation of the interface to version 2.3 of
xgrab, describing the commands provided by the system.  The first two
appendices
explain the proper syntax for
the two types of files read by xgrab:  graph input
files and command input files.  The third appendix lists the valid values
for built-in attributes (see below).  This document assumes
that the user is familiar with \fIX\fP.
.PP
Please send comments and bug reports to
\fBgreg@cs.washington.edu\fR.
.NH
Xgrab's notion of a graph
.PP
An xgrab graph consists of a set of \fInodes\fR, and a set of directed 
\fIedges\fR.
An edge is identified by the two nodes which are its endpoints.  The endpoints
cannot be the same node, that is, self-loops are not allowed.
.PP
Each node and each edge has a set of \fIattributes\fR, some of which are 
built-in,
and some of which are defined by the user.  A node has three \fIbuilt-in 
attributes\fR:  its \fIshape\fR, such as \fIrectangle\fR, \fIcircle\fR, or
\fIdiamond\fR; its \fIbrush\fR,
that is, what types of lines it is drawn with, such as \fIbold\fR, 
\fIdashed\fR, 
or \fIdotted\fR; and its \fIcolor\fR, such as \fIblack\fR or \fIwhite\fR.  
An edge has two built-in
attributes:  brush and color.
.PP
In addition to the built-in attributes there are 
\fIuser-defined attributes\fR,
a set of them for the nodes, and a set for the edges.
There can be any number of attributes, as long as there is at least one
for the nodes and one for the edges.  One of the node attributes is the 
\fIdistinguished node attribute\fR, otherwise known as the \fItext\fR or the
\fIlabel\fR for the nodes.  Similarly, there is a \fIdistinguished edge
attribute\fR, also known as the label or text for the edges.
.PP
When drawing the graph, besides the nodes and edges given, xgrab might draw
\fIdummy nodes\fR, small placeholder nodes in the middle of long edges.  
For more information about dummy nodes, see the references in the document,
\fIIntroduction to GRAB\fR.  Dummy nodes are second-class citizens in the
xgrab world, and shouldn't be treated as normal nodes.
.NH
Getting started
.PP
To run xgrab, you
must first start up \fIX\fP and open a shell window.  When
invoking xgrab, you may specify the name of an input file
containing information about the graph to be displayed.  (Alternatively
you may start up xgrab with no input file and use the \fIChange
File Name\fR and the \fIRead File\fR command in the "File" menu, or just
start adding nodes manually.)  A
description of the format of the input file is given in Appendix A.
For now, you may simply wish to use an existing sample file, such as
\fIdata/Nsample\fP in the standard distribution.
.PP
Xgrab can be run in the background, since it will open up its
own window.  To browse the sample file, enter the command
.DS
%\ xgrab data/Nsample &
.DE
After a short pause, xgrab will open a window, the \fIxgrab window\fR.
When the layout computation is
complete, the graph will be displayed in the window.  The title for the
graph (as specified in the input file) and the name of the input file
will appear at the top of the window.  After the graph has been drawn,
xgrab will open a second window, the \fIgraph attributes window\fR.
This window will be discussed later.  Concentrate on the xgrab window 
for now.
.PP
If all the nodes of the graph are large enough to hold the text of
their names, the names will be displayed; otherwise, the names will not
be displayed, and it will be necessary to enlarge the window or to zoom
in on selected sections of the graph for the names to be
printed.
.PP
Both windows can be moved, stretched, etc. by using the
standard window manipulation functions provided by \fIX\fP.  You
may wish to experiment by changing the window size; notice that
when the xgrab window is made sufficiently small, the text in the nodes 
will no longer be printed.
.NH
User Interface Overview
.PP
This section presents an overview of xgrab's user interface.
.NH 2
Xgrab Windows
.PP
The Xgrab window can be divided into six regions:  the text
area, the buttons area, the graph area, the adjuster, the built-in attributes
display, and the user-defined attributes display.
.PP
The text area is at the top of the window, and contains three
fields:  the graph name, the file name, and the status line.  The graph
name field contains the name of the current graph, the file name field
contains the name of the current file, and the status line field is
used for printing various status information.  
.PP
The buttons area is right below the status region, separated by
a horizontal line.  
The buttons area consists of four menu buttons:  "Command", "Edit",
"Options", and "File".  A pop-up menu will appear when
the cursor is positioned on one of these menu buttons and a mouse button is
pressed.  To the right of these buttons are the mode buttons, labeled
"Browse", "Change", and "Edit".  The box to the left of each button
indicates which of the three is the current mode.  There is one and only
one current mode at any given time.
.PP
The graph area occupies most of the window, and is used to display
the graph being browsed.  It is separated from the buttons area by another
horizontal line.
.PP
The adjuster is found to the left of these three areas, and consists of a
rectangular area called a slider, four buttons arranged like a compass, called
the panner, and two three-dimensional-looking buttons called the zoomer.
These devices can be used to adjust your view of the graph area:  the zoomer
allows you to zoom in or out; the panner allows you to move right, left, up,
or down; the slider allows you to `drag' the view 
around in a limited
way, as well as providing a clue as to what portion of the graph is displayed
in the graph area.
.PP
The built-in attributes display, just above the adjuster,
consists of three pairs of buttons and text:
"shape", "brush", and "color", and a depiction of what the current values
for these three attributes mean.  By pressing the buttons, you can change 
their values, which in turn changes the text and the depiction, and has an 
effect on other commands you might invoke.
.PP
The user-defined attributes display is not displayed when the program is first 
started, but only when specifically requested by the user.  It appears above 
the built-in attributes display and consists of a list indicating the
values of the user-defined attributes for a node or edge.
.PP
The graph attributes window consists of five buttons and two lists of 
attributes.  Using the buttons and the menus, the user can control which 
attributes will be displayed in the user-defined attributes display.
.PP
The following sections describe each of the above in more detail, except
for the text area, which is so simple it doesn't require any more.
.NH 2 
Adjuster Operations
.PP
The user can use the adjuster to change what portion of the graph is
displayed in the graph area.  Think of the entire graph as being somewhere
else, and the graph area as a `view' of the graph.  
The panner and zoomer are devices for moving the view left and right, up
and down, in and out.  If you press the panner button on the right, you've
moved the view to the right, so what was formerly offscreen on the right
is now visible, while what was on the far left has disappeared.  If you
press the top zoomer button, you've moved the view closer to the graph,
so that 
less of the
graph
appears on screen, but what is visible
appears bigger.
.PP
The slider serves two purposes:  to show what portion of the graph is
visible, and to provide another method of panning about
the graph.  To understand the first function, you should use the top zoomer
button (zoom in) a few times, so that the entire graph is not visible on
the screen.  If you look at the slider now, you will see a white rectangle
in the center of a gray rectangle.  The gray rectangle represents the
entire graph.  The white rectangle represents the portion visible in the
graph area.  Now, you can use the second function of the slider.  
Place the mouse inside the white rectangle, 
press and hold down a button, and move the
mouse about.  The rectangle will move with the mouse (although the mouse 
can't be
moved outside the slider area).  When you release the button, the visible
area will change to
where the white rectangle is.  This allows you to pan in two
dimensions, although in a somewhat coarser way.
.PP
The program makes an attempt to keep node labels readable by adjusting the
font to fit the size of the nodes.  If the nodes become too small, the
node labels will disappear (unless the \fIPrint Node Label\fR option is set.
See the "Options menu").  Edge labels will also change, always in a font
of lesser or equal size to the node font.
.PP
The factors by which you move up/down/right/left/in/out can be changed
using the \fISet Pan Gradient\fR and \fISet Zoom Gradient\fR entries
in the "Options" menu.  Besides the adjuster, the view of the graph
area can be changed using various \fIFocus\fR commands (see the "Edit" menu
and Appendix B), the \fISize to Fit\fR command (see the
"Edit" menu), and, implicitly, the \fILayout Graph\fR and \fIRead File\fR
commands (see the "Commands" and "File" menus).
.PP
The slider has a few other functions, which can be discovered through 
experimentation.
To learn more about the slider, see the \fISlider\fR manual page that comes 
with
the distribution of the InterViews user interface package.
.NH 2
The Built-in Attributes Display
.PP
Apart from changing the text and the depiction of the display itself, 
the buttons in the built-in
attributes display have little immediate effect.  It is only when certain
actions in the graph area are invoked that the significance of this area
becomes clear.  These actions are \fISet Node\fR, \fISet Edge\fR, 
\fISet In/Out Edges\fR, \fIReset Node\fR, \fIReset Edge\fR, 
\fIReset In/Out Edges\fR, \fICycle Node\fR, and \fICycle Edge\fR; from
their names you can guess what they do.  The built-in attributes display
defines `current' values for the built-in attributes, and these commands 
use the current values to decide how to change nodes/edges.
.PP
Each built-in attribute has a set of possible values, listed in Appendix
C.
The current values for the attributes can be changed by pressing 
the buttons in the built-in attributes display.  
In addition to the valid values, there is an extra value
representing \fBno value\fR at all (no shape, no brush, or no color).
The right mouse button for
an attribute cycles forward through all possible values for the attribute,
the left mouse button cycles backward.  The middle mouse button resets the
attribute to its \fBno value\fR.  
.PP
As the current value changes, the text to the left of the button, and the
depiction above the buttons change to reflect the current values for all three
attributes.  If an attribute has no value, the default value for the
attribute is used in the depiction (see Appendix C for the default values
for each attribute).
.PP
The \fBno value\fR has special meaning when the actions listed above are
invoked:  if an attribute has no value, that attribute is not changed,
no matter which of the actions is invoked.  See the section, 
`Graph Area Operations', for
more details.
.NH 2
The Graph Attributes Window and the User-defined Attributes Display
.PP
As with the built-in attributes display, the buttons in the graph
attributes window don't have much immediate effect by themselves.  The
graph attributes window contains five buttons and a list of the node and
edge attributes for the graph.  The buttons and the list of attributes
themselves can be used to select which attributes will be shown in the
user-defined attributes display.
.PP
The \fINode Set All\fR, \fINode Clear\fR, \fIEdge Set All\fR, and \fIEdge
Clear\fR buttons do the obvious thing:  select or unselect all of the node
or edge attributes.  Individual attributes can be toggled by clicking the
mouse button inside the attribute's box.  When an attribute is
selected, an asterisk appears next to its name.  
.PP
If the user finds the graph
attributes window annoying, she can always use the \fIClose\fR button to
remove it from the screen.  
If she has a change of heart, she can always bring it back using the \fISet
Displayed Attributes\fR command in the "Options" menu.
The window will always reappear when the
attributes of a graph change (for example, after a new graph is read in).
The first time the window appears, the user must place it herself, but
afterwards the window will be drawn with its upper left corner in the same
place as the upper left corner of its previous incarnation.
.PP
If no attributes for the graph are defined (for instance, if xgrab was
invoked without an input file), the program will assume boring
default values for the attribute names and the window will appear anyway.
.PP
The user-defined attributes display can be created using the \fIShow
Attributes\fR action in the graph area.  The display, annoyingly enough,
isn't really part of the xgrab window, so if you perform window operations
on the xgrab window, the display will stay where it is.  Fortunately, you
can always delete it using the \fIDelete Attributes Display\fR action in
the graph area.
.NH 2
Buttons Area Operations
.PP
As explained above, there are four menu buttons in the buttons area.
The pop-up menu associated with each menu box is activated when the cursor is 
over a menu box and a mouse button is pressed.  The user can then choose the
desired action from the pop-up menu.  Before explaining these actions,
let's consider the mode buttons.
.PP
Mode buttons indicate which of the three modes the program is in:
"Browse", "Change", or "Edit".  These modes are explained in the section, 
`Graph Area Operations', below.  
The "x" in the box next to a button indicates
this is the current mode.  To change the mode, press a mouse button over
the box or the label for the button.  Isn't that neat?  On to the menu
actions:
.KS
.NH 3 
Menu Actions
.NH 4 
Commands Menu
.LP
.TS
tab(+) allbox center doublebox;
c cw(3.5i)
l lw(3.5i).
\fBCommand menu item+action\fR
_
\fBRedisplay Screen\fR+T{
Redisplays the entire xgrab window.
T}
\fBRedraw Graph\fR+T{
Redraws the graph area.
T}
\fBLayout Graph\fR+T{
Runs the layout algorithm on the current graph.
Useful if nodes or edges have been added to or deleted from the graph.
T}
\fBPrint Screen (PostScript)\fR+T{
Creates a PostScript version of the screen in the file \fBscreen.ps\fR, 
suitable for use with \fIlpr\fR on devices that support PostScript and use
8.5" x 11" paper.  See the section, `Postscript files', below.
T}
\fBShow Levels\fR+T{
Draws lines which show the level structure used in laying out the
graph, for those interested in that sort of thing.
To get rid of the level lines, do a \fIRedraw Graph\fR.
T}
\fBHelp\fR+T{
Prints out help screens.  They're not wrong, but they are kind of terse.
Read the documentation instead.
T}
\fBExit\fR+T{
Exits xgrab.  
The program will ask for confirmation if the graph has been modified since
the last time a file was read.
T}
.TE
.KE
.KS
.NH 4 
Edit Menu
.LP
.TS
tab(+) center allbox doublebox;
c cw(3.5i)
l lw(3.5i).
\fBEdit menu item+action\fR
_
\fBChange Node Text\fR+T{
Changes the text of a node.  After this command is selected,
move the cursor to the node whose text you want to change, and then 
click the left mouse button.  A dialog box 
will appear, and the node text can be entered.
T}
\fBChange Edge Label\fR+T{
Changes the label of an edge.  After this command is selected, 
move the cursor to the edge whose text you want to change, and then
click the left mouse button.  A dialog box will 
appear, and the edge text can be entered.
T}
\fBSize To Fit\fR+T{
Adjust the view of the graph so that the entire graph is visible, the graph
is centered in the screen, and the graph is as large as possible.
This command is useful when you have zoomed in several levels and want to 
return to the global view.  The command is implicitly executed after a
graph is layed out.
T}
\fBFocus on Node\fR+T{
Focus on a node.  After this command is chosen, move the cursor to the
node on which you want to focus, and click the left mouse button.  The view
of the graph will be adjusted so that the node is in the center of the
view, large enough for the node label to show.  If the node label is
already visible, the size of the node will remain unchanged; only the
centering will be done.
T}
\fBFocus on Named Node\fR+T{
Same as \fIFocus on Node\fR, except the user specifies the label of the node
to be focussed upon.  If more than one node has that name, only one is
focussed upon (obviously).
T}
\fBCreate Checkpoint\fR+T{
Create a checkpoint.  Later checkpoints are discarded.  For this and the
next two commands, see the section, `Checkpoints', below.
T}
\fBPrevious Checkpoint\fR+T{
Go to the previous checkpoint.  If a change has occurred since the last
checkpoint was created, go to that one, otherwise go to the one before it.
T}
\fBNext Checkpoint\fR+T{
Go to the next checkpoint.  
T}
\fBExecute Commands in File\fR+T{
Execute the commands in a file on the current graph.  A dialogbox 
appears for the user to type the name of the file.  For
more information, see the section, `Command Files', below.
T}
.TE
.KE
.KS
.NH 4 
Options Menu
.PP
There are two types of menu items in the options menu: toggle items
and vanilla items.
The text of the toggle menu items will be preceded by either a space or
an asterisk.  A space preceding the menu item text means that the option is
off, while an asterisk preceding the menu item text means that the option is
on.
Vanilla menu items are identical to menu items encountered in other menus.
.PP
The following items are of the toggle variety.
.TS
tab(+) center allbox doublebox;
c cw(3.5i) c
l lw(3.5i) l.
\fItoggle\fR \fBmenu item+action+default\fR
_
\fBPrint Node Label\fR+T{
Forces the node labels to be printed even if they won't fit inside the nodes.
Note that there is no way to force node labels to \fInot\fR be printed if
they do fit inside the nodes.
T}+off
\fBMark Dummy Nodes\fR+T{
Marks all dummy nodes in the graph by drawing teeny boxes where the
dummy nodes are.
T}+off
\fBDraw Arrows\fR+T{
When on, arrowheads are drawn on the edges.  When off, 
the arrowheads are not displayed, but almost all operations
requiring the redrawing of the graph will be faster.
T}+on
\fBPrint Edge Label\fR+T{
Displays the edge labels when on.
Again, most operations will be faster if this option is off.
T}+off
\fBChange In Edges\fR+T{
If on, the \fISet In/Out Edges\fR and \fIReset In/Out Edges\fR commands 
in the graph area affect the inedges of a node.
T}+off
\fBChange Out Edges\fR+T{
If on, the \fISet In/Out Edges\fR and \fIReset In/Out Edges\fR commands 
in the graph area affect the outedges of a node.  \fIChange In 
Edges\fR and \fIChange Out Edges\fR can be on simultaneously.
T}+off
\fBRotate PostScript File\fR+T{
Create PostScript files that come out sideways, like a landscape picture.
T}+off
\fBShow BC\fR+T{
Display the barycenter of the nodes, just in case you care.
T}+off
\fBDebug Mode\fR+T{
Turns on all sorts of debugging stuff.
T}+off
\fBStraighten Edges\fR+T{
Causes the layout algorithm to attempt to draw dummy nodes in long segments
of straight lines.  Not really noticeable in small graphs.
T}+off
\fBIgnore Hidden\fR+T{
Causes the predicate (command) evaluation routines to ignore hidden nodes.
For more information, see the section, `Command Files', below.
T}+on
.TE
.KE
.KS
.LP
The rest of the menu items are of the vanilla variety.
.sp
.TS
tab(+) center allbox doublebox;
c cw(3.5i) c
l lw(3.5i) l.
\fIvanilla\fR \fBmenu item+action+default\fR
_
\fBSet Zoom Gradient\fR+T{
Sets the zoom factor (see \fIAdjuster Operations\fR, above).  
Should be a number between zero and one.  A negative
zoom factor would be a bad thing.  A zoom factor greater than 1 would
reverse the meanings of the zoomer buttons (the top one would zoom out,
the bottom would zoom in).
T}+0.75
\fBSet Pan Gradient\fR+T{
Sets the pan gradient (see \fI Adjuster Operations\fR, above).  
Should be a value between zero and one.  A negative pan gradient would
reverse the meanings of the buttons.  A pan gradient greater than 1
wouldn't be such a bad thing; it means you pan by a distance at
least as large as the
size of the screen.
T}+0.05
\fBShow Layout Stats\fR+T{
Display layout information, in case you care.
T}+none
\fBShow Program Stats\fR+T{
Display resource utilization information.
T}+none
\fBShow Region Sizes\fR+T{
Display window, view, bounding box, etc., sizes.
T}+none
\fBDump Node List\fR+T{
Debugging information, or for those who are easily amused.
T}+none
\fBSet Displayed Attributes\fR+T{
Popup the graph attributes window if it's been closed, print an error
message if it hasn't.
T}+none
.TE
.KE
.KS
.NH 4 
File Menu
.PP
All file commands act on the \fIcurrent file name\fR.  The current file
name is set with the \fIChange File Name\fR command.
.TS
tab(+) center allbox doublebox;
c cw(3.5i)
l lw(3.5i).
\fBFile menu item+action\fR
_
\fBChange File Name\fR+T{
Change the current file name.  The new file name can be typed into the
dialog box.
T}
\fBRead File\fR+T{
Read a new graph from the current file.  The current file can be set by the 
\fIChange File Name\fR command.
T}
\fBWrite File\fR+T{
Write the graph to the current file.  The current file will then
contain information about the layout (but see `Command Files' below); 
when the file is read in later,
xgrab will use the layout information in the file to recreate your
edited version.  The current file can be set by the \fIChange File 
Name\fR command.  
T}
\fBWrite File (PostScript)\fR+T{
Creates a PostScript version of the graph 
suitable for use with \fIlpr\fR on devices that support PostScript and use
8.5" x 11" paper.  
The name of the output file will be your current file name, 
with the suffix ".ps" added.  
See also the section, `Postscript files', below.
T}
.TE
.KE
.bp
.NH 3 
PostScript Files
.PP
The PostScript version of a graph differs in a few ways from the version
displayed in the graph area.  Node labels will always be displayed,
because of the font scaling capabilities of PostScript (although fonts are
never scaled too large).  The \fIMark Dummy Nodes\fR option is ignored when
creating PostScript files.  The \fIPrint Arrows\fR option is followed, as
are the \fIShow BC\fR and \fIPrint Edge Label\fR options (but see below).
As mentioned above, the graph can be drawn
either vertically or horizontally, depending on the value of the \fIRotate
PostScript file\fR option.
.PP
The greatest change concerns the \fIPrint Node Label\fR option.  If
the font would be scaled too small (to an unreadable size), and this option
is set, the node labels are printed outside the node (in the lower right),
in a font deemed just large enough to read.  If the labels are printed
here, edge labels and barycenters are omitted altogether, regardless of the
values of the other options.
.NH 3
Dialog Boxes, Changing Labels, and Focussing on Nodes
.PP
It should be noted that dialog boxes, like the user-defined attributes
display, are not really part of the xgrab window, so X operations performed
on the xgrab window will not affect dialog boxes.
.PP
The presence of dialog boxes, as well as invoking the \fIChange Node
Text\fR, \fIChange Edge Label\fR, and \fIFocus on Node\fR commands, inhibits
certain other events from being processed.  \fINo\fR other actions can be 
performed
while a dialog box is present.  This is true to a lesser extent
when the user is supposed to be choosing a node or edge for a change label
or focus command.  No graph area operations can be performed at this time.
However, if one of the buttons in the buttons area is pressed 
at this time, the focus or change label command 
is aborted and life goes on.  The user can still
press buttons in other areas of the graph, such as the graph attributes
window, the built-in attributes display, or even the adjuster.  It's not
recommended, but she can.
.PP
Incidentally, the cursor can be anywhere in the graph area to type text
into a dialogbox.
.NH 3
Checkpoints
.PP
Checkpoints allow the user to save the current digraph state and come back
to it later.  Checkpoints are numbered for reference, and you can go
backward or forward through the list of checkpoints.  There is the obvious
notion of a
`current' checkpoint, which becomes important for the \fICreate
Checkpoint\fR command.  If there are checkpoints after the current one, and
the user creates a checkpoint, those checkpoints are deleted.  So, for
example, if you have 3 checkpoints, and you go back to checkpoint #1 and
create a checkpoint, the old checkpoints 2 and 3 are lost, and the new
checkpoint is number 2.
.PP
Checkpoints only save the graph and its layout, not the view of the graph,
so when you return to a checkpoint an implicit \fISize to Fit\fR command is
done, as if it had just been layed out.
.NH 3
Command Files
.PP
The program allows the user to execute a list of commands (also 
known as predicates
or filters) on the graph.  The syntax of the commands is pretty basic; a
grammar is given in Appendix B.  Here we are concerned with the semantics
of these files.
.PP
The files are executed in the following manner:  A list of all the nodes
(excluding dummy nodes)
and edges is created; all the commands are executed sequentially on the 
first element of the list, then all the commands are executed sequentially
on the second, then the third, and so on.
When writing files, it would not be a good idea, 
software engineering-wise, to rely on a certain ordering of
the nodes and edges in the list.  Relying on a certain ordering of the
commands is okay, though.
.NH 4
Operands
.PP
The commands understand six types of objects:  \fIliteral strings\fR,
\fIstring attributes\fR, \fIgraph elements\fR,
\fIsets of graph elements\fR,
\fIboolean values\fR, and \fIboolean attributes\fR.  
Literal strings and boolean values can only be used as rvalues.
Attribute strings and boolean attributes are the only lvalues
allowed (they can also be used as rvalues).  Graph elements and sets of 
graph elements are commonly used as
command operands.
.PP
Literal strings are
denoted by
double quotation marks (`"').  String attributes 
are denoted by a graph element, followed by an attribute
name, and evaluate to the value of that attribute for that element.  
If the graph element does not have an attribute matching the name
given, it is an error (but see the \fBset\fR statement below).  The names
\fBshape\fR, \fBbrush\fR, and \fBcolor\fR correspond to the string
representations of the appropriate built-in attributes (see Appendix C).
\fBShape\fR is not a valid attribute name for edges.
The strings
"true" and "false" are considered to be the appropriate boolean values.
All other strings have an undefined boolean value.  
.PP
Boolean values are represented by the strings "true" and "false" (hence the
automatic type conversion implied by the previous sentence).  Boolean
attributes are denoted just as string attributes, but only the attributes
\fBnode\fR, \fBedge\fR, \fBdisplayed\fR, and \fBcoalescer\fR are defined.
\fBNode\fR or \fBedge\fR is true if the element is a node or edge,
respectively.  \fBDisplayed\fR is true if a node is displayed,
\fBcoalescer\fR true if it is coalesced.  Neither is a valid attribute for
an edge.  For an explanation of the last two attributes, see the 
section, 
`Commands'
below.
.PP
Graph elements are either nodes or edges of the graph, and are denoted by
a period (`.'), a literal string followed by a period, or an attribute
(string or boolean, although the former makes more sense), 
followed by a period.
.PP
A period alone indicates the current graph
element (the one the commands are being
executed upon).  A literal string followed by a period indicates the
node/edge whose distinguished attribute is equal to the string.  
An attribute followed by a period means the node/edge whose distinguished
attribute is equal to the value of the attribute.  
In the last two cases, if more
than one node/edge match the string, one of them is picked.  If none do, it
is an error.
.PP
A graph element is implicitly the same as a set of graph elements with one
member.
.PP
A set of graph elements is denoted in the same way as a graph
element, except that 
\fIrelatives\fR attributes can be used where attribute names would normally
appear.  The following are valid
relatives attributes:  \fBparents\fR, \fBchildren\fR, \fBancestors\fR, 
\fBdescendants\fR,
\fBout\fR, \fBin\fR, \fBsource\fR, \fBsink\fR.  The latter two are defined
only on edges, the former six only on nodes.  \fBSource\fR, \fBsink\fR, 
\fBparents\fR, and
\fBchildren\fR are pretty self-explanatory.  \fBIn\fR
is the set of inedges of a
node, \fBout\fR
the set of outedges.  \fBAncestors\fR is the transitive closure of the
\fBparents\fR relation, \fBdescendants\fR the transitive closure of the 
\fBchildren\fR
relation.
.PP
Note that relatives of sets are valid sets (for 
example, .\fBchildren\fR.\fBoutedges\fR,
the outedges of the children of the current node), as are attributes of
sets (.\fBoutedges\fR.EdgeLabel, all the elements whose distinguished
attribute matches one of the labels of the outedges of the current node.
As before, though, each EdgeLabel can only match one element).
.PP
Sets of graph elements of size one can be considered to be a graph 
element, but only if they were created from a set of size one.  So, for
example, (.\fBchildren\fR.\fBchildren\fR
is a valid graph element if and only if the
current node has one child, and that node has one child).  Sets 
of size zero are valid.  Using a set of graph elements not
of size one where a graph element is required is an error (but
see the \fBset\fR statement below).
.NH 4 
Commands
.PP
The following are valid commands.  All commands must end in a semicolon,
except for the \fBif\fR command, where the \fBendif\fR is sufficient:
.IP
\fBif\fR -- The standard 
\fBif\fR/\fBthen\fR/\fBelsif\fR/\fBelse\fR/\fBendif\fR command.  See the
appendix if you don't understand the syntax.  The usual crowd of boolean
operators (\fBand\fR, \fBor\fR, \fBnot\fR, and \fB=\fR) is also around.
The boolean operators \fBand\fR, \fBor\fR and \fBnot\fR work on boolean 
values and return boolean values.  The \fB=\fR operator takes two values
(string or boolean) and returns a boolean value.
.IP
\fBset\fR -- Set an attribute of a set of graph elements to a value.  
For the \fBset\fR statement only,
if the attribute name is not defined (and is not a reserved word), the
attribute is created for all graph elements of the same kind (node or
edge).  For example, 
.DS
set "someNode".foo = "bar"; 
.DE
could create an attribute named foo for all nodes (assuming someNode is a
node and not an edge, and there is currently no node attribute named "foo").  
The new attribute will be the null string except
where set.
.IP
Setting sets of attributes is valid, for example,
.DS
set .children.NodeLabel = "mychildren";
.DE
.IP
\fBcontinue\fR -- Skip the rest of the commands for this element.
Analogous to the same statement in C.
.IP
\fBbreak\fR -- Stop executing commands altogether.  Analogous to the same
statement in C.
.IP
\fBfocus\fR -- Focus on a set of nodes (not valid on edges).  Only the last
focus command seen is actually executed.
.IP
\fBhide\fR -- Mark a set of node as hidden (not valid on edges).  
This means the node and all associated edges are virtually ignored by the
rest of the program.  They aren't displayed on the screen, they aren't
considered on layout, etc.  They \fIcan\fR be considered when executing commands
by turning off
the \fIIgnore Hidden\fR option.  If this option \fIis\fR set, the node
immediately becomes invisible after a \fBhide\fR command.
So, for example, if you give the command
.DS
hide .;
.DE
and \fIIgnore Hidden\fR is set,
that will be the last command executed on the current node.
.IP
Unfortunately, the graph input routines don't understand hidden nodes, so
if a graph with hidden nodes is written to a file, no mention is made of
the hiding (and the graph must be layed out again when read in).  Jumping
ahead a bit, the same is true for coalesced nodes.  The input routines
don't understand them, so coalesced nodes are written as uncoalesced 
and the coalescer nodes disappear.
.IP
\fBdisplay\fR -- Mark a set of nodes as displayed (not valid on edges).  The 
opposite of hide.  Obviously, this command is utterly useless unless
\fIIgnore Hidden\fR is not set.
.IP
\fBcoalesce\fR -- Coalesce a set of nodes to a node (the \fIcoalescer
node\fR.  Not valid on edges).
This has the effect of combining the set and the coalescer node into 
one node, with
the same built-in and user-defined attributes as the coalescer node.  The
coalescer node will have an outedge set equal to the union of all the
outedges of the coalesced nodes and itself (excluding edges between the
coalesced nodes).  Similarly, the inedges of the coalescer will be a union
of the inedges of the coalesced nodes and itself, with the exception of
edges between the coalesced nodes. 
.IP
If
the node named as the coalescer is not currently a coalescer node, a
coalescer is first created with 
the node as its sole component.  Coalescing a node
to itself has no effect if the node is already a coalescer.  
A coalescer node can itself be coalesced to another node; it is
treated just as a normal node would be.
.IP
Coalesced nodes are automatically marked as hidden.  
Coalesced nodes can \fInever\fR be
accessed by the user, except by expanding their coalescer (see below), or
writing the graph to an output file.
.IP
\fBexpand\fR -- Expand a coalescer node (not valid on edges.  If the node
is not a coalescer, this command has no effect).  The coalescer node goes
away and its components reappear.  All components of a coalescer are
defined as \fBdisplayed\fR after an \fBexpand\fR command. 
.IP
As mentioned above, coalescer nodes can be coalesced themselves.  For
example, consider a graph containing six nodes labeled "A", "B", "C", "D",
"E", and "F".  Let n(x, y, z) stand for a coalescer node labeled n with
components x, y, and z.
The state of the graph after executing these commands
is as follows:
.DS
coalesce "A". "B".;	5 nodes:  C, D, E, F, B(A, B)
coalesce "C". "D".;	4 nodes:  E, F, B(A, B), D(C, D)
coalesce "E". "D".;	3 nodes:  F, B(A, B), D(C, D, E)
coalesce "D". "F".; 	2 node :  B(A, B), F(F, D(C, D, E))
expand "B".;		3 nodes:  A, B, F(F, D(C, D, E))
expand "F".;		4 nodes:  A, B, F, D(C, D, E) 
expand "D".;		6 nodes:  A, B, C, D, E, F
.DE
.NH 2
Graph Area Operations
.PP
There are three modes of operation in xgrab: \fIbrowse\fR mode, 
\fIchange\fR mode, and
\fIedit\fR mode, as explained in the section, `Buttons Area Operations',
above.  Change mode is for changing built-in attributes of nodes and edges.
Edit mode is for moving, deleting, or inserting nodes and edges.  Browse
mode is for displaying user-defined attributes of nodes and edges, plus a
couple of functions that really belong in change mode, except there aren't
enough buttons on a standard mouse to put them there.
.PP
The \fBmeta\fR, \fBshift\fR, and \fBcontrol\fR keys can be used to
temporarily put the user into browse, change, and edit modes, respectively.  
So, for
example, pressing the shift key while pressing a mouse button will give you
the action associated with the mouse button when the program is in change
mode, regardless of what the mode buttons say.  Similarly, the control key
plus a mouse button gives you the edit mode action, and the meta key plus a
mouse button gives you the browse mode action.
.PP
Some window managers allow the user to define special functions for these keys,
however, and it's likely those functions will override the xgrab functions.
The program attempts to rectify this by defining other keys as 
substitutes: the space bar
should act as the meta key for purposes of changing
modes, \fBz\fR, \fBZ\fR,
\fB/\fR, and \fB?\fR should act as the shift key, and \fBa\fR, \fBA\fR,
\fB\'\fR, and \fB"\fR should act as the control key.  Unfortunately, the
InterViews software (used to implement event handling among other
things) chooses to ignore key
release events for an extremely stupid reason, which means the program will
think you're still pressing one of these keys after you release it,
until another key is pressed.  You can use this knowledge as you wish:
remember which key you pressed last, or only use the shift, meta and
control keys and work around your window manager, or just use the mode
buttons and ignore this feature altogether.
.PP
Returning to things that do work:  the cursor will change shape when you
pass over a node (where it will become a crosshairs) or over an edge (where
it
will become a reversed, white arrow).  Some leeway is given, so the program
will think you're over a node or edge if you're in the neighborhood (where
the neighborhood is about 3 pixels on all sides).  Also, the cursor gives
priority to nodes over edges, edges over dummy nodes.  This only becomes a
problem when you want to delete a dummy node:  the cursor will never change
to a crosshairs because you can be sure if you're in the neighborhood of a
dummy node you're also in the neighborhood of an edge.  If you've got an
eagle eye, though, you can take your chances.
.PP
The semantics of the mouse buttons in the graph area changes depending on which 
which mode xgrab is in.  The following sections describe the mouse
functions, grouped by the current mode.  In the following sections, the
node or edge the cursor is positioned over
is the
\fIcurrent\fR node or edge.
.NH 3
Mouse Buttons: \fIBrowse\fR mode
.NH 4 
Left Mouse Button -- \fISet In/Out Edges\fR
.PP
Change the built-in
attributes of the in- and/or out-edges of the current node to
those in the built-in attributes display.  In this and other \fISet\fR
functions, recall that an attribute is not changed if its current value is
\fBno value\fR.  Whether the inedges, outedges, both or neither are
affected depends on the values of the \fIChange Inedges\fR and \fIChange
Outedges\fR options.  Not valid on dummy nodes.
.NH 4
Middle Mouse Button -- \fIReset In/Out Edges\fR
.PP
Reset the built-in
attributes of the in- and/or out-edges of the current node to
their default values.  In this and other \fIReset\fR functions, recall that
an attribute is not changed if its current value is \fBno value\fR.
Whether the inedges, outedges, both or neither are affected depends on the
values of the \fIChange Inedges\fR and \fIChange Outedges\fR options.  Not
valid on dummy nodes.
.NH 4
Right Mouse Button -- \fIShow Attributes\fR, \fIDelete Attributes Display\fR
.PP
Display the user-defined
attributes for the current node or edge in the user-defined
attributes display.  Which attributes are displayed depends on the values
in the graph attributes window.  If the cursor is not over a node or edge,
the user-defined attributes display is deleted.
.NH 3
Mouse Buttons: \fIChange\fR mode
.NH 4 
Left Mouse Button -- \fISet Node\fR, \fISet Edge\fR
.PP
Change the built-in
attributes of the current node or edge to those in the built-in
attributes display.
.NH 4 
Middle Mouse Button -- \fIReset Node\fR, \fIReset Edge\fR
.PP
Reset the built-in
attributes of the current node or edge to their default values.
.NH 4 
Right Mouse Button -- \fICycle Node\fR, \fICycle Edge\fR
.PP
Cycle through all possible values for the built-in attributes of a node or
edge.  If you think of the attributes as a three-digit number, with the
shape as the least significant and the color as the most significant digit,
then cycling is just like counting (edges, of course, ignore the shape
attribute).  Just as with the \fISet\fR and
\fIReset\fR functions, if the current value of an attribute is \fBno
value\fR, it is ignored in the cycling process.
.NH 3
Mouse Buttons: \fIEdit\fR mode
.NH 4 
Left Mouse Button -- \fIInsert Node\fR, \fIInsert Edge\fR
.PP
Insert a node or an edge 
into the
graph.  A node can be inserted into the graph by clicking the left
mouse button when the cursor is not over an existing node.  After the
button is clicked, there will be a prompt on the status line asking you
to type in the label of the new node.  After you type in the label of the
new node and hit <return>, the new node will be drawn.  If you wish to
cancel this command, you can press the "cancel" button in the dialogbox.
.PP
An edge can be inserted into the graph by pressing the left mouse
button when the cursor is over an existing node, holding the button
down until you have moved the cursor to the destination node, and then
releasing the button.  
If you release the button when the cursor is not over a
node, a dummy node will be created at the position where you released
the button, and the edge insertion process will go on from there.  
You can proceed to drop more dummy nodes or to terminate
the edge by clicking the button when the cursor is over a non-dummy
node.
.PP
You cannot insert an edge to or from a dummy or coalescer node, or from a
node to itself (even if there are intervening dummy nodes).  If there is
already an edge between the two endpoints of your new edges, your new edge
will be erased and redrawn to follow the path of that edge.  This could
provide endless hours of entertainment for the easily amused.
.NH 4
Middle Mouse Button -- \fIMove Node\fR
.PP
Move the current node.
Press and hold the
middle button, and you can "drag" the
node around in the window.  Releasing the middle button will place the
node at its new position.  You cannot drag the center of the
node out of the graph area.
.NH 4
Right Mouse Button -- \fIDelete Node\fR, \fIDelete Edge\fR
.PP
Delete the current node or an edge.
If a node is deleted, any associated edges are deleted, too (exception:  if
a dummy node is deleted, the edge(s) between the node before the dummy node
and the node after straighten out).  Although a dummy node with
multiple edges will be drawn as a
set of adjacent dummy nodes, all these are actually one and 
the same node; if one is
deleted, they all go away.
.PP
If one edge in a set of edges between two nodes is deleted, 
it might create a gap, which in most cases will not be filled.  To fill the
gap, the graph must be relayed out.
.NH
\fBAppendix A:  Graph File Format\fR
.PP
This appendix describes the file format for xgrab graphs.  The
format allows graphs that have or have not been layed out by xgrab
to be represented.  The file format is as follows:
Fields are separated by whitespace
(any combination of spaces and/or tabs).  Newlines indicate the end 
of a node, edge, template, or whatever and are not valid whitespace.
Optional fields are indicated in brackets (`[]').  If a field is included, 
all previous fields on the line must also be included.  If no graph name 
is given, the *NAME* line can be omitted.
.DS
    ...
    ...
[*NAME*
one line description of the graph]
*NODES*
\fIdistinguished_node_attribute_name\fR [\fInode_attribute_name\fR ...]
\fIcode\fR [\fIdistinguished_node_attribute\fR] [\fInode_attribute\fR ...] [\fIshape\fR] [\fIbrush\fR] [\fIcolor\fR] [\fIx\fR \fIy\fR] [\fIstatus\fR] [\fIlevel\fR \fIposition\fR]
   ...
   ...
*EDGES*
\fIdistinguished_edge_attribute_name\fR [\fIedge_attribute_name\fR ...]
\fIfrom_code\fR \fIto_code\fR [\fIdistinguished_edge_attribute\fR] [\fIedge_attribute\fR ...] [\fIbrush\fR] [\fIcolor\fR] [\fIreversed\fR]
   ...
   ...
.DE
.PP
All lines before the *NAME* line (or the *NODES* line if there is no *NAME*
line) are ignored.
The distinguished attribute is used to label the node/edge.
Extra fields at the end of a line are ignored.  If no distinguished 
attribute is given for a node, the code is used instead.  If 
user-defined
attributes are omitted for a particular node or edge they are considered 
to be the null string.  If you wish to give a null field explicitly, 
use the string "..."
.PP
The \fIcode\fR for a node is a unique identifier, used primarily in the
edge list.
The \fIx\fR, \fIy\fR, \fIstatus\fR, \fIlevel\fR, \fIposition\fR, and 
\fIreversed\fR attributes give layout information and should probably not
be supplied by the user.  If \fIall\fR the attributes for \fIall\fR
the nodes are not
supplied, the program assumes the graph hasn't been layed out and lays it
out after reading it in.
.PP
All attributes are strings, except for \fIx\fR, \fIy\fR, \fIlevel\fR 
and \fIposition\fR, which are integers.  Strings are separated by
whitespace;  strings with whitespace can be include by surrounding the
string with double quotation marks (`"').  The quotation marks are not
included in the string.  Two types of backslash escapes (for
quotation marks and backslashes) can be included in
the string.
For valid shape, brush, color, and status strings, see Appendix C.
\fIReversed\fR is a boolean string.
.PP
As an example, the
following graph has one user-defined node attribute, two user-defined
edge attributes,
two nodes, and two edges, 
.sp 1
.DS
*NAME*
Simple Graph
*NODES*
nodelabel
node1  label1
node2  "built-in attributes given"  circle  dotted  gray 
*EDGES*
edgelabel  "edge attribute 2"
node1  node2  "only one attribute given"
node2  node1  "all attr given"  "2nd attr"  bold  black  false
.DE
.NH
\fBAppendix B:  Command File Format\fR
.PP
The following is a grammar for the command files.  Tokens are separated by
whitespace (if necessary).  Strings and quoted strings are about what you'd
expect them.  All reserved words and tokens are in bold, variables are in
italics.  The start symbol is \fIcommand_list\fR.
.sp
.DS
\fIcommand_list\fR	-> \fIcommand\fR [\fIcommand_list\fR]
\fIcommand\fR 		-> \fIhidestmt\fR | \fIifstmt\fR | \fIsetstmt\fR | \fIcoalescestmt\fR | 
		   	   \fIexpandstmt\fR | \fIdisplaystmt\fR | \fIfocusstmt\fR | \fIbreakstmt\fR | 
		   	   \fIcontinuestmt\fR | \fB;\fR
\fIhidestmt\fR 		-> \fBhide\fR \fInode\fR \fB;\fR
\fIdisplaystmt\fR 		-> \fBdisplay\fR \fInode\fR \fB;\fR
\fIfocusstmt\fR 		-> \fBfocus\fR \fInode\fR \fB;\fR
\fIexpandstmt\fR 		-> \fBexpand\fR \fInode\fR \fB;\fR
\fIbreakstmt\fR 		-> \fBbreak\fR \fB;\fR
\fIcontinuestmt\fR 	-> \fBcontinue\fR \fB;\fR
\fIcoalescestmt\fR 	-> \fBcoalesce\fR \fInode\fR \fInode\fR \fB;\fR
\fIifstmt\fR 		-> \fBif\fR \fIbexpr\fR \fBthen\fR \fIcommand_list\fR
	           	   [\fBelsif\fR \fIbexpr\fR \fBthen\fR \fIcommand_list\fR ...]
	           	   [\fBelse\fR \fIcommand_list\fR]
	           	   \fBendif\fR
\fIsetstmt\fR 		-> \fBset\fR \fIattr\fR \fB=\fR \fIrval\fR \fB;\fR
\fIattr\fR 			-> \fIfnodel\fR \fB.\fR \fIrest_of_attr\fR
\fIattr_name\fR 		-> \fIstring\fR | \fBbrush\fR | \fBshape\fR | \fBcolor\fR | \fBdisplayed\fR | \fBcoalescer\fR |
		   	   \fBnode\fR | \fBedge\fR
\fIrest_of_attr\fR 	-> \fIattr_name\fR | \fInodel\fR \fB.\fR \fIrest_of_attr\fR
\fInode\fR 			-> \fIfnodel\fR \fB.\fR [\fIrest_of_node\fR]
\fIrest_of_node\fR 	-> \fInodel\fR \fB.\fR [\fIrest_of_node\fR]
\fIfnodel\fR 		-> \fIquoted_string\fR | e		e = empty string 
\fInodel\fR 		-> \fIstring\fR | \fBin\fR | \fBout\fR | \fBsource\fR | \fBsink\fR | \fBparents\fR | \fBchildren\fR |
  		   	   \fBancestors\fR | \fBdescendants\fR
\fIrval\fR 			-> \fIattr\fR | \fIquoted_string\fR
\fIbexpr\fR 		-> \fIbterm\fR | \fIbterm\fR \fBand\fR \fIbexpr\fR | \fIbterm\fR \fBor\fR \fIbexpr\fR
\fIbterm\fR 		-> \fBnot\fR \fIbfactor\fR | \fIbfactor\fR
\fIbfactor\fR 		-> \fB(\fR \fIbexpr\fR \fB)\fR | \fIrval\fR | \fIrval\fR \fB=\fR \fIrval\fR
.DE
.bp
.NH
\fBAppendix C:  Valid attribute strings
.PP
Case doesn't matter for strings.  If the meaning of string isn't obvious,
the right-hand column should explain it.
.TS
tab(+) center allbox doublebox;
c cw(1.5i)
l cw(1.0i).
\fBShape strings+meaning\fR
_
rectangle+
circle+
diamond+
oval+
point+
double_box+
rect+rectangle
box+rectangle
ellipse+oval
dot+point
default+rectangle
.TE
.TS
tab(+) center allbox doublebox;
c cw(1.5i)
l cw(1.0i).
\fBBrush strings+meaning\fR
_
solid+
bsolid+bold solid
dotted+
bdotted+bold dotted
dashed+
bdashed+bold dashed
bold+bold solid
default+solid
.TE
.TS
tab(+) center allbox doublebox;
c cw(1.5i)
l cw(1.0i).
\fBColor strings+meaning\fR
_
black+
gray+
grey+
white+
default+black
.TE
.TS
tab(+) center allbox doublebox;
c cw(1.5i)
l cw(1.0i).
\fBStatus strings+meaning\fR
_
normal+
dummy+
default+dummy
.TE
.TS
tab(+) center allbox doublebox;
c cw(1.5i)
l cw(1.0i).
\fBBoolean strings+meaning\fR
_
false+
true+
.TE
.NH
Notes
.PP
Oh yeah, \fIPostScript\fR
is a trademark of Adobe Systems Incorporated, and \fIX Window System\fR
is a trademark of the Massachusetts Institute of Technology.  This document 
was derived from an earlier document written by the GRAB group at UC 
Berkeley.
